﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Core.Primitives;
using Infragistics.UltraChart.Resources.Appearance;
using Infragistics.UltraChart.Data.Series;
using System.Collections;

namespace TreeMapChartDataClickedEvent
{
    public partial class Form1 : Form
    {
        private System.Data.DataTable dataTable1;
        //set to the index values of your string columns
        private int[] _indexOrder = new int[] { 0, 1, 2 };
        //set to the size value index 
        private int _sizeValueIndex = 3;
        //set to the color value index
        private int _colorValueIndex = 4;
        //used to calculate row and column values on the treemap datapoints
        private int ROW = 0;
        private int COL = 0;

        //used to map row and column values to the hierarchy
        private Hashtable mapping = new Hashtable();
        public Form1()
        {
            InitializeComponent();
            this.ultraChart1.ChartType = Infragistics.UltraChart.Shared.Styles.ChartType.TreeMapChart;
            this.dataTable1 = new System.Data.DataTable();

            this.dataTable1.Columns.Add("COL1", typeof(string));
            this.dataTable1.Columns.Add("COL2", typeof(string));
            this.dataTable1.Columns.Add("COL3", typeof(string));
            this.dataTable1.Columns.Add("Cost ($)", typeof(double));
            this.dataTable1.Columns.Add("COL5", typeof(double));
            this.dataTable1.Rows.Add("Food", "Crunchies", "Crackers", 15.0, 9.00);
            this.dataTable1.Rows.Add("Food", "Crunchies", "Biscuits", 1.5, 0.9);
            this.dataTable1.Rows.Add("Food", "Fruit", "Bananas", 11.2, 0.8);
            this.dataTable1.Rows.Add("Food", "Fruit", "Apples", 14.3, 0.7);
            this.dataTable1.Rows.Add("Candy", "CandyBars", "", 9.4, 0.5);
            this.dataTable1.Rows.Add("Food", "Fruit", "Oranges", 10.9, 0.2);
            this.dataTable1.Rows.Add("Drink", "Coke", "", 2.4, 0.0);
            this.dataTable1.Rows.Add("Drink", "Milk", "", 15.9, 0.0);
            this.dataTable1.Rows.Add("Drink", "OJ Soda", "", 3.0, -0.1);
            this.dataTable1.Rows.Add("Drink", "Water", "", 8.1, -0.3);
            this.dataTable1.Rows.Add("Drink", "Cran-Ras", "", 8.0, -0.5);
            this.dataTable1.Rows.Add("Drink", "Gatorade", "", 8.0, -0.7);
            this.dataTable1.Rows.Add("Candy", "Skittles", "", 20.0, -1.0);
            this.ultraChart1.DataSource = this.dataTable1;
            this.ultraChart1.DataBind();

            //creates the has for mapping the row and column labels to the hierarchy
            CreateHash(this.dataTable1);
        }
        void CreateHash(DataTable _dt)
        {
            SeriesCollection seriesToUse = new SeriesCollection();
            int rowCount = 13;
            int columnCount = 5;
            DataTable dt = new DataTable();
            for (int i = 0; i < columnCount; i++)
            {
                dt.Columns.Add(_dt.Columns[i].ColumnName as string);
            }
            for (int currentRow = 0; currentRow < rowCount; currentRow++)
            {
                object[] objValues = new object[columnCount];
                for (int i = 0; i < columnCount; i++)
                {
                    objValues[i] = _dt.Rows[currentRow][i];
                }
                dt.Rows.Add(objValues);
            }
            TreeMapDataPoint temp = new TreeMapDataPoint();

            _convertChartDataToTreeMapData(temp, dt, 0);

            TreeMapSeries series = new TreeMapSeries();
            foreach (TreeMapDataPoint point in temp.Points)
            {
                series.Points.Add(point);
            }

            seriesToUse.Add(series);

            TreeMapDataPoint root = new TreeMapDataPoint();

            foreach (TreeMapDataPoint point in ((TreeMapSeries)seriesToUse[0]).Points)
            {
                root.Points.Add(point);
            }

            double weight = root.SizeValue;
            double colorWeight = root.ColorValue;
            string s = root.Label;
            Box B = new Box(new System.Drawing.Rectangle());//this.OuterBound);
            TMBox tmb = new TMBox(B);
            tmb.SizeValue = weight;
            tmb.ColorValue = colorWeight;
            tmb.Label = s;
            tmb.Depth = -1;
            tmb.DataPoint = null;
            _addToScene(tmb, seriesToUse[0], "");

            double valueSum = root.SizeValue;
            _recursiveDrawRectangular(root, 0, seriesToUse[0], "");
        }
        #region modified source code
        private void _addToScene(TMBox tmb, ISeries series, string hier)
        {
            Box B = tmb.Box;
            bool isLeaf = false;
            if (tmb.DataPoint != null && tmb.DataPoint.HasChildren == false)
            {
                isLeaf = true;
            }
            if (isLeaf)
            {
                mapping.Add(ROW + "," + COL, hier);
            }
            B.Row = ROW;
            B.Column = COL;
            ROW++; // increment row and leave col static.
            //COL++;
        }

        private void _recursiveDrawRectangular(TreeMapDataPoint parent, int depth, ISeries series, string hier)
        {
            this.COL++;
            double netSum = parent.SizeValue;

            List<TreeMapDataPoint> Points = new List<TreeMapDataPoint>();

            foreach (TreeMapDataPoint point in parent.Points)
            {
                if (!point.Empty)
                {
                    Points.Add(point);
                }
            }
            Points.Sort();


            #region rectangle algorithm
            for (int i = 0; i < Points.Count; i++)
            {
                // get strings and their weights from SortedStrings in descending order
                // of weight.
                int max_index = Points.Count - 1;
                TreeMapDataPoint point = (TreeMapDataPoint)Points[max_index - i];

                if (point.SizeValue == 0.0 || point.Empty)
                {
                    // don't draw this rectangle or any of its children.
                    continue;
                }

                double percentArea = Math.Abs(point.SizeValue) / netSum;
                System.Drawing.Rectangle R = new System.Drawing.Rectangle();
                TMBox tmb = new TMBox(new Box(R));
                tmb.SizeValue = point.SizeValue;
                tmb.ColorValue = point.ColorValue;
                tmb.Label = point.Label;
                tmb.Depth = depth;
                tmb.DataPoint = point;
                netSum -= Math.Abs(point.SizeValue);
                _addToScene(tmb, series, hier);
                if (point.HasChildren)
                {
                    string temp = hier;
                    if (temp == string.Empty)
                    {
                        temp = point.Label;
                    }
                    else
                    {
                        temp += ("," + point.Label);
                    }
                    _recursiveDrawRectangular(tmb.DataPoint, depth + 1, series, temp);
                }
            }
            #endregion
            return;
        }

        private void _convertChartDataToTreeMapData(TreeMapDataPoint parent, DataTable dt_in, int depth)
        {
            List<string> strings = new List<string>();
            //StringCollection strings = new StringCollection();
            DataRow[] rows_in = dt_in.Select();
            if (_indexOrder.Length == 0)
            {
                #region we have no string columns.
                for (int current = 0; current < rows_in.Length; current++)
                {
                    DataRow currentRow = rows_in[current];
                    TreeMapDataPoint child = new TreeMapDataPoint();
                    try
                    {
                        if (Convert.IsDBNull(currentRow[_sizeValueIndex]))
                        {
                            child.SizeValue = 0.0;
                        }
                        else
                        {
                            child.SizeValue = Convert.ToDouble(currentRow[_sizeValueIndex]);
                        }
                    }
                    catch
                    {
                        child.SizeValue = 0.0;
                    }
                    try
                    {
                        if (Convert.IsDBNull(currentRow[_colorValueIndex]))
                        {
                            child.ColorValue = 0.0;
                        }
                        else
                        {
                            child.ColorValue = Convert.ToDouble(currentRow[_sizeValueIndex]);
                        }
                    }
                    catch
                    {
                        child.ColorValue = 0.0;
                    }
                    child.Label = "ROW " + current;
                    parent.Points.Add(child);
                }
                return;
                #endregion
            }
            int col = _indexOrder[depth];
            foreach (DataRow row in rows_in)
            {
                string s = row[col] as string;
                if (!strings.Contains(s))
                {
                    strings.Add(s);
                }
            }

            if (depth == _indexOrder.Length - 1) // leaves have been reached: compute values and end recursion
            {
                foreach (string s in strings)
                {
                    TreeMapDataPoint newPoint = new TreeMapDataPoint();
                    newPoint.Label = s;
                    double sum = 0.0;
                    double colorSum = 0.0;
                    foreach (DataRow row in rows_in)
                    {
                        if ((row[col] as string) == s)
                        {
                            double objVal;
                            double objColorVal;
                            try
                            {
                                if (Convert.IsDBNull(row[_sizeValueIndex]))
                                {
                                    objVal = 0.0;
                                }
                                else
                                {
                                    objVal = Convert.ToDouble(row[_sizeValueIndex]);
                                }
                            }
                            catch
                            {
                                objVal = 0.0;
                            }
                            try
                            {
                                if (Convert.IsDBNull(row[_colorValueIndex]))
                                {
                                    objColorVal = 0.0;
                                }
                                else
                                {
                                    objColorVal = Convert.ToDouble(row[_colorValueIndex]);
                                }
                            }
                            catch
                            {
                                objColorVal = 0.0;
                            }
                            sum += objVal;
                            colorSum += objColorVal;
                        }
                    }
                    newPoint.SizeValue = sum;
                    newPoint.ColorValue = colorSum;
                    if (s == "" && strings.Count == 1)
                    {

                    }
                    else
                    {
                        parent.Points.Add(newPoint);
                    }
                }
            }
            else // leaves have not been reached: continue recursion
            {
                foreach (string s in strings)
                {
                    TreeMapDataPoint newPoint = new TreeMapDataPoint();
                    newPoint.Label = s;
                    DataTable dt_out = dt_in.Clone();
                    double sum = 0.0;
                    double colorSum = 0.0;
                    foreach (DataRow row in rows_in)
                    {
                        if ((row[col] as string) == s)
                        {
                            dt_out.ImportRow(row);

                            double objVal;
                            double objColorVal;
                            try
                            {
                                if (Convert.IsDBNull(row[_sizeValueIndex]))
                                {
                                    objVal = 0.0;
                                }
                                else
                                {
                                    objVal = Convert.ToDouble(row[_sizeValueIndex]);
                                }
                            }
                            catch
                            {
                                objVal = 0.0;
                            }
                            try
                            {
                                if (Convert.IsDBNull(row[_colorValueIndex]))
                                {
                                    objColorVal = 0.0;
                                }
                                else
                                {
                                    objColorVal = Convert.ToDouble(row[_colorValueIndex]);
                                }
                            }
                            catch
                            {
                                objColorVal = 0.0;
                            }
                            sum += objVal;
                            colorSum += objColorVal;
                        }
                    }
                    newPoint.SizeValue = sum;
                    newPoint.ColorValue = colorSum;
                    if (s == "" && strings.Count == 1)
                    {
                        _convertChartDataToTreeMapData(parent, dt_out, depth + 1);
                    }
                    else
                    {
                        parent.Points.Add(newPoint);
                        _convertChartDataToTreeMapData(newPoint, dt_out, depth + 1);
                    }
                }
            }
        }

        private class TMBox
        {
            private Box _box;
            private double _weight;
            private double _colorWeight;
            private string _label;
            private int _depth;
            private TreeMapDataPoint _dataPoint;
            public TMBox(Box B)
            {
                _box = B;
            }
            public Box Box
            {
                get
                {
                    return _box;
                }
                set
                {
                    _box = value;
                }
            }
            public double SizeValue
            {
                get
                {
                    return _weight;
                }
                set
                {
                    _weight = value;
                }
            }
            public double ColorValue
            {
                get
                {
                    return _colorWeight;
                }
                set
                {
                    _colorWeight = value;
                }
            }
            public string Label
            {
                get
                {
                    return _label;
                }
                set
                {
                    _label = value;
                }
            }
            public int Depth
            {
                get
                {
                    return _depth;
                }
                set
                {
                    _depth = value;
                }
            }
            public TreeMapDataPoint DataPoint
            {
                get
                {
                    return _dataPoint;
                }
                set
                {
                    _dataPoint = value;
                }
            }
        }
        #endregion

        private void ultraChart1_ChartDataClicked(object sender, Infragistics.UltraChart.Shared.Events.ChartDataEventArgs e)
        {
             Primitive p = e.Primitive;
        string hierachy = (string)mapping[e.DataRow + "," + e.DataColumn];
        if (hierachy == string.Empty)
        {
            e.RowLabel.ToString();
        }
        else
        {
            string str = hierachy + ","+e.RowLabel;
        }
        }
    }
}
